#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// strdup - duplicate a string
char* strdup(const char* str)
{
	char* dup = (char*)malloc((strlen(str)+1) * sizeof(char));
	if (dup != NULL) 
	{
		strcpy(dup, str);
	}
	return dup;
}

int main()
{
	char str[100] = "lets rock";
	char * dup;

	dup = strdup(str);
	printf("%s\n", dup);
	printf("str address is %p, dup address is %p\n", str, dup);

	free(dup);
	return 0;
}