#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_LEN 100
#define ARR_INIT_SIZE 2


typedef struct customer_t
{
	char name[MAX_LEN+1];
} Customer;

typedef struct dyn_array_t
{
	Customer * arr;
	int size;
	int capacity;
} Darray;

void readString(char string[],int size)
{
	int i=0;
	char * c;
	scanf("%c",&c);
	while ((c!='\n')&&(i<size))
	{
		string[i]=c;
		i++;
		scanf("%c",&c);
	}
	string[i]='\0';
}
 

Darray init_array(int size)
{
	Darray darr;

	darr.arr = (Customer *)malloc(size*sizeof(Customer));
	if (darr.arr == NULL) {
		printf("Memory allocation failed\n");
		exit(1);
	}
	darr.size = size;
	darr.capacity = 0;

	return darr;
}

void insert(Darray * darr, Customer customer)
{
	if (darr->capacity == darr->size)
	{
		darr->arr = (Customer *)realloc(darr->arr, darr->size*2*sizeof(Customer));
		if (darr->arr == NULL)
		{
			printf("Memory allocation failed\n");
			exit(1);
		}
		darr->size*= 2;
	}
	darr->arr[darr->capacity] = customer;
	darr->capacity++;
}

int main()
{
	Darray dynamic_array = init_array(ARR_INIT_SIZE);
	int i;
	Customer customer;

	// insert customers
	for (i = 0; i < 10; ++i)
	{
		printf("insert customer %d:\n", i+1);
		readString(customer.name, MAX_LEN);
		insert(&dynamic_array, customer);
	}
	// print array
	for (i = 0; i < 10; ++i)
		printf("Customer %d: %s\n", i+1, dynamic_array.arr[i].name);

	free(dynamic_array.arr);

	return 0;
}




	}
	darr->arr[d